      program extrjason
C.................................................................Jan 2016
C extract/interpolate pTEC from Jason2 files
C LocalTime grids maps in IONEX grids for glats=-87.5,-85,...,85, 87.5 (1 to 71 lines)
C                         glongs=-180,-175,...0,5,...,180 (0 to 72 cols.)
C
	DIMENSION res(71,0:72),ires(0:72)
	+,pinp(71,0:24,0:23),XX(0:23),zinp(71,0:24),YY(0:72) ! -180:5:180 yglon
	CHARACTER*65 infile,outfile
		CHARACTER*2 AYR,AMN,ALT
C 
  101	format(73(1X,F5.1))
   17 format (A2)
   18 format (4X,F6.1,5X,F5.1,24(3X,F8.4))
      WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
      WRITE(*,*)' ENTER MN OF INPUT FILE=	'
	read(*,17) AMN

	infile='JS2_LT_MN_20YR.dat' 
	outfile='pjMN00LT.hYR'		   ! LT monthly maps
      WRITE(*,*)' YR = ',AYR,' MN=',AMN
	infile(8:9)=AMN
	infile(13:14)=AYR

	outfile(3:4)=AMN
	outfile(11:12)=AYR
C
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	OPEN(10,file=infile,action='READ')

C
    1	continue
   13 FORMAT(I2)
	DO 200 ilon=1,24
C	nlat=73
	DO 201 nlat=71,1,-2 
C	nlat=nlat-2  !nlat=71 for glat=87.5; nlat=1 for glat=-87.5
	read(10,18,end=199) xlon,xlat,(XX(k),k=0,23)
	do k=0,23
	if (XX(k).gt.998.) XX(k)=-0.1 

	pinp(nlat,ilon,k)=XX(k)
	enddo
 201	CONTINUE		 ! cycle ilat

 200	CONTINUE		 ! cycle ilon
 199  CLOSE(unit=10)
C Interpolate to IONEX grids each map for given LT:
C Cycle on LT
	do 190 ihr=0,23
	call blet2(ihr,ALT)
	outfile(7:8)=ALT
	OPEN(11,file=outfile)
C
	gilat=-92.5
C 
	DO ilat=1,71,2
	gilat=gilat+5.0
C 
      pinp(ilat,0,ihr)=pinp(ilat,24,ihr) !Copy pTEC at glon=352.5 => glon=-7.5
	do ilon=0,24
	zinp(ilat,ilon)=pinp(ilat,ilon,ihr)
	enddo
	ENDDO
C glats interpolation
	gilat=-90.0
       DO ilat=2,70,2
	gilat=gilat+5.0
C Interpolate in lats:
	do ilon=0,24
	x1=zinp(ilat-1,ilon)
	x2=zinp(ilat+1,ilon)
	rr=0.
	if ((x1.lt.0.).and.(x2.lt.0.)) then 
	rr=-0.1 
	                                   else
	if ((x1.lt.0.).and.(x2.gt.0.)) rr=x2
	if ((x1.gt.0.).and.(x2.lt.0.)) rr=x1
	if (rr.eq.0.0) rr=(x1+x2)/2.
	                                  endif
	zinp(ilat,ilon)=rr
	enddo
	ENDDO
C glons interpolation
	gilat=-90.0
	DO ilat=1,71
	gilat=gilat+2.5
	gilon=-20.0
	kk=33
	DO ilon=1,24
	gilon=gilon+15.
	kk=kk+3
	x1=zinp(ilat,ilon-1)
	x2=zinp(ilat,ilon)
	rr=0.
		if ((x1.lt.0.).and.(x2.lt.0.)) then  !<<<<<<<<<<<<<<<<
	rr=-1.0
 	y1=-1.0 
	y2=-1.0 
	y3=-1.0 
	                                   else	 !<<<<<<<<<<<<<<<<
	if ((x1.lt.0.).and.(x2.gt.0.)) then
	rr=x2
	y1=-1.0
	y2=-1.0
	y3=x2
	endif
	if ((x1.gt.0.).and.(x2.lt.0.)) then
	rr=x1
	y1=x1
	y2=-1.0
	y3=-1.0
	endif
		if (rr.eq.0.0) then
	y1=x1+(x2-x1)/6.
	y2=x1+(x2-x1)/2.
	y3=x1+(x2-x1)/1.2
	endif
	endif                             !<<<<<<<<<<<<<<<<<<<<
	if (gilon.lt.175.) then	   !++++++++
	YY(kk-1)=y1
	YY(kk)=y2 
	YY(kk+1)=y3
   				   else		   !+++++++
	if (gilon.eq.175.) then
	YY(71)=y1
	YY(72)=y2
	YY(0)=y2
	YY(1)=y3
                      else
C gilon.gt.180:
	YY(kk-73)=y1
	YY(kk-72)=y2
	YY(kk-71)=y3
	endif
	            endif          !+++++++++
	ENDDO  ! gilon cycle
		do jlon=0,72
	res(ilat,jlon)=YY(jlon)
	ires(jlon)=nint(YY(jlon)*100.)
	enddo
	write(*,19) (ires(k),k=0,72)
	write(11,19) (ires(k),k=0,72)


	ENDDO  !gilat cycle
	close(unit=11)
	 
  190	CONTINUE
   19	format(73(1X,I4))
   2	continue
c-      pause ' '
	stop
	end