      program ionexdaymapupc
C..............................................................May 2023
C
C..............................................................Sep  2020
C produce diurnal results in formal JPL_IONEX format in geogr. coords 
C glat = -87.5:2.5:87.5
C glon=-180:5.0:180 
C infile: fcMNDDUT.jYR,hcMNDDUT.jYR,tcMNDDUT.jYR,wcMNDDUT.jYR, 
C oufile: /web/graf/dfc/YR/YRMNDDf.txt, ...
C
C..............................................................Aug. 2017
C Produce CoM Hc-map in IONEX from JPL-GIM-TEC divided hourly IONEX maps
C Input:
C JPL GIM-TEC IONEX maps in geomag coords d:\web\dhc\YR\MN\coMNDYUT.jYR
C Output: 
C Maps in geomag coord. mglats -87.5:2.5:87.5 , Mglongs 0:5:360
C	   
      DIMENSION IM(12)
	CHARACTER*2 ayr,amn,ady
	CHARACTER*4	AYEAR
		CHARACTER*1 fhts
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Test
C	outfile='d:\web\dhc\YR\yrmnddc.txt'  !Hc diurnal file in JPL_IONEX format mag.coord
C	infile='d:\web\graf\dhc\YR\MN\ut\fcmnddut.jYR'	 ! foF2 in geogr. coord.
C 
   1        WRITE(*,*)' ENTER AYEAR (0000=stop):'
		READ(*,15) AYEAR
	      WRITE(*,*)' ENTER MN :'
		READ(*,*) imn
	      WRITE(*,*)' ENTER DY :'
		READ(*,*) idy

C
   14	FORMAT(A1)
   15	FORMAT(A4)
C
	AYR=AYEAR(3:4)
	read(AYEAR,*) ryear
	IYYYY=int(ryear)   ! current yr
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C
C monthly cycle
C==	imn2=12
Crem      if (iyyyy.eq.2020) imn2=9 ! temp
Cnorm       DO 40 imn=1,imn2
Crem       imn=9
	call blet2(imn,AMN)
C
  199	format(A2)
C
C Day-to-day cycle
       nmdy=im(imn)
C==	DO 200 idy=1,nmdy
C-      idy=16
	call blet2(idy,ADY)
C
C Produce daily file in JPL IONEX format
C++	        fhts='f'  ! foF2
C++	call mapionexwf(fhts,ayear,amn,ady) ! in mag. coord
C++	        fhts='h'  ! hcF2
C++	call mapionexwf(fhts,ayear,amn,ady) ! in mag. coord
C++	        fhts='t'  ! tcF2
C++	call mapionexwf(fhts,ayear,amn,ady) ! in mag. coord
	        fhts='w'  ! W-index
	call maprionexupc(fhts,ayear,amn,ady) ! in mag. coord
  200	CONTINUE  ! next day
   40	CONTINUE  ! next month
Ctemp	if (iyyyy.lt.2020) GOTO 1
    2     	pause ' '
      STOP
	end