      program devtcw15np
C........................................................Nov 2020
C Include JPL-based TEC IONEX maps in geogr coords d:\web\graf\dtc\YR\MN\ut\tcMNDYUT.jYR
C jp='j'
C output: wc-index => d:\web\graf\dwc\YR\MN\ut\wcMNDYUT.jYR
C........................................................Oct 2015
C else: jp='j'
C Separate W-index 
C
C
C Maps in geogr coord. glats -87.5:2.5:87.5 , glongs -180:5:180
C
C........................................................Feb 2015
C Enter dy1,dy2
C .......................................................
C Geographic grids maps for glats=-87.5,-85,...,85, 87.5 (1 to 71 lines)
C                         glongs=-180, -1`75,..., 0,5,...,180 (0 to 72 cols.)
C
C........................................................
C Only W-index maps from JPL-based hourly foF2 maps 
C
C
C
C For 1h_input IONEX-TEC-based foF2map files: d:\web\graf\dfc\YY\MM\ut\fcMMDDUT.jYY
C Input: prec_mn (all days) into lines 1:7(last day of prec_mn) and current_mn (till given day=>8 line) for fixed UT
C
C Change+++ Produce median for -15 preceding days (instead of 27 prec days)
C
C OUTPUT : S index global map : d:\web\dfv\YY\MM\fiMMDDUT.jYR		!Vs(foF2)
C
C
C T.L.Gulyaeva .................................................July 2007
C
C FORMAT from 15 prec. days
C Include logarithmic scale indices -4,  -3,    -2,    -1,0, 1,    2,    3,   4
C NO!!!  Equivalent to log10(TEC/TECmed)= <-.301, -.155, -.045   0,  0.45, .155, .301 >
C MEW: Dynamic S-class storm thresholds according to -STD1, +STD2
C                              
C Ref. Gulyaeva T.L. Logarithmic scale of ionospheric disturbances,
C      Geomagn.and Aeronomy, 1996, 36, 1, 160-163, 1996.
C
      DIMENSION IM(12)
     +,DA(0:28,0:72,71) ! foF2 14prec_days+curr_day=15,longs=0:72,lats=71
     +,XMED(0:72,71),DEV(0:72,71)
	dimension rx(0:72)
	+,CC(15,0:72),SMED(0:72),STD(0:72),STD1(0:72),STD2(0:72)
	integer*4 IRES(0:72,71)
Cnorm	+,imed(0:72,71),irat(0:72,71)
Cnorm	+,istdp(0:72,71),istdn(0:72,71)
	integer*2 IYR,IMN,IDY,IUT,jyr_pre,jmn_pre,jdy_pre
	+,IDY1,IDY2,nndy !Maps available for idy1 to idy2; extrap. to IDY2+1,idy2+2
     +,imni,iyri
	CHARACTER*48 INFILE1,INFILE2,OUTFILE !Vfs=vindex
C?	+,OUTFILED,OUTFILEM ! DELTA(foF2),MED_15(foF2)
C?	+,outfilesp,outfilesn !STD1(Vp),STD2(Vn)
	CHARACTER*2 AYR
	+,AUT,AMN,ADY,PYR,PMN,PDY
	+,AYRI,AMNI
	CHARACTER*1 ft,fht,jp
C--		COMMON /BL1/CC,SMED,STD,STD1,STD2
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C
      ft='t'  ! TEC-map
	jp='j'	   ! GIM_tcF2 maps from JPL GIM-TEC

C=    WRITE(*,*)' CHECK AVAILABILITY of fc files '
C=	pause  ' '
  333	WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
ctemp	AYR='09'
cc	write(*,17) ' YR=',ayr
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
Cnorm	imn=0
C+      write(*,*) ' Enter current mon:'
C+	read(*,*) imn
C	imn=7            ! start for mn=3, 1989; from mn=8, 1957
C       imn=1			  !NORM
1333	CONTINUE
C      imn=imn+1
C	if (imn.gt.12) STOP ! for full year
C-      WRITE(*,*)' ENTER MN  or 00 for stop'
C-	READ(*,13) IMN
        DO 155 imn=1,12
C-	if(imn.eq.0) STOP
ctemp	imn=07
C
       write(*,*) ' Month:',imn
   13 FORMAT(I2)
ctemp	idys=1           ! Cycle on day-to-day
C?	WRITE(*,*)' ENTER IDY1,IDY2'
C?	READ(*,13) IDYS,IDYS2

	idys=1		   !++
	IDYS2=im(imn)  !++
C-      	IDYS2=28  !++
 201	CONTINUE		 ! cycle on days
	AYRI=AYR
   17 format (A2)
	iyri=iyr
	pyr=AYR ! prec_year
	jyr_pre=iyr
C

	call blet2(imn,amn)  ! current month
	AMNI=AMN
	imni=imn
	jmn_pre=imn
C

200   continue	  
	idy1=idys
C
C preceding month:
	if (imn.gt.1) then
	jmn_pre=imn-1			 ! prec_mn
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=iyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN)   ! prec_mn
C
CNO!!	IDY2=IDY1  !?????????????????????????????????????
	IDY2=idys2
C
	fht='t'				! only TEC source map
	lda1=ndoy(iyr,imn,idy1)
C
C-     	 infile1='d:\web\dfs\YY\MM\fcMMDDUT.jYY'   ! preceding mn
     	 infile1='d:\web\graf\dtc\YY\MM\ut\tcMMDDUT.jYY'   ! preceding mn
C-	if (jp.eq.'p') then
C-	infile1(10:10)='c'        ! PRIME foF2 maps
C-	infile1(27:27)='p'
C-	endif

	infile1(14:14)=ft
	infile1(26:26)=ft
	 infile2=infile1  ! current mn
	
 	infile1(17:18)=pyr
	infile1(20:21)=pmn
 	infile1(36:37)=pyr
	infile1(28:29)=pmn
 	infile2(17:18)=ayr
 	infile2(36:37)=ayr
	infile2(20:21)=amn
	infile2(28:29)=amn
C
	outfile='d:\web\dws\YY\MM\wcMMDDUT.jYY'   ! current mn
	outfile(12:13)=ayr
	outfile(15:16)=amn
	outfile(28:29)=ayr
	outfile(20:21)=amn
C
C
C  Start cycle on UT		=======================================================================
C
C     	 infile1='d:\web\graf\dfc\YY\MM\ut\fcMMDDUT.jYY'   ! preceding mn
C
	DO 300 iut=0,23
	call blet2(iut,AUT)
	infile1(32:33)=aut
	infile2(32:33)=aut
	outfile(24:25)=aut
C add 
		ut=float(iut)
 

C	 DA(0:28,0:24,35)
	 DO n=1,71				! lats
	      DO I=0,28			! 27 prec days
       DO K=0,72				! lons
	      DA(I,K,n)=0.
	 enddo
	      ENDDO
	ENDDO

c	 ,XMED(0:24,35)
 	do k=0,72
	do i=1,71
	ires(k,i)=0
	xmed(k,i)=0.
       DEV(k,i)=0.
	enddo
	enddo
C  Avoid input of prec. month:
crem	nnd1=idy1-6
      ncnt=0        ! count of days 1,2,...,15   
      if (idy1.gt.14) goto 230	  ! goto input of current month
C  1st input of preceding mon-data

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	nndy=im(jmn_pre)	  ! prec. mn
C???	nnd1=nndy-6
	nnd1=nndy-13
	if (idy1.gt.1) nnd1=nnd1+idy1-1
C
C  day-to-day input for prec mon
C
	DO 400 jdy_pre=nnd1,nndy  ! for fixed UT
	call blet2(jdy_pre,PDY)
	infile1(30:31)=pdy

		OPEN(109,FILE=INFILE1)
C	     DA(0:8,0:72,35) ! 7prec_days+curr_day=8,longs=0:72,lats=35
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cr	glat=-90.
 	DO ilat=1,71	  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (109,107,END=106,ERR=2) (rx(k),k=0,72)
C
C
c.		! TEC at glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
	da(28,k,ilat)=rx(k) ! TEC 
	enddo
C
	ENDDO				  !< LAT-BY-LAT
  107	FORMAT(73(1X,F4.1))		   
  106	close(unit=109)					!     end of prec_mn input
C Move data day-by-day up so that last day of month nndy=>day_27:
C
c--	do ish=1,nndy-27      ! shift cycles
 	do ilat=1,71		  ! < LAT-BY-LAT
	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up  
	enddo				  ! all longi
	enddo				  ! all days
	enddo				   ! all lati
	ncnt=ncnt+1
c--	enddo                 ! end shift cycle
  400	CONTINUE		  !<day-by-day
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C start cycle on day-to-day for current mon  ======================================
C
  230	continue
	nndy=im(imn)	 ! end of current month

  490 format(1X,' year=',I2,' month=',I2,' day=',I2,' ut=',I2)
	idy=0
CREM	idy=idy1-1
C
C Current month
C
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy3, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
	lday2=ndoy(iyr,imn,idy2) ! function to define day-of-year
      if (lday.gt.lday2) then
	goto 500 ! end of day-to-day processing 
	endif
C-      if (idy.gt.nndy) then
C-	idy=1
C-	imn=imn+1
C-	endif
ctemp		WRITE(*,490) iyr,imn,idy,iut
	call blet2(iyr,AYR)
	call blet2(imn,AMN)
	call blet2(idy,ADY)
	infile2(30:31)=ady
C
 	infile2(17:18)=ayr
 	infile2(36:37)=ayr
	infile2(20:21)=amn
	infile2(28:29)=amn
C++
  700 format(A128)
C++
C
C   reading map for current month
C
cr	glat=-90.
 704 	 continue
c++	 outfile='d:\web\dwf\YY\MM\wfMMDDUT.jYY'   ! current mn
	outfile(18:19)='wc'		   ! Wf index in geogr coord from JPL GIM_fcF2

C	Median output:
C??	OUTFILEM=OUTFILED
C??	outfilem(8:10)='dem'
C??	outfilem(18:19)='tm'		 ! median -15d

		OPEN(110,FILE=INFILE2)
       do 600 ilat=1,71,1		  ! < LAT-BY-LAT
cr	glat=glat+5.0
	READ (110,107,END=108,ERR=2) (rx(k),k=0,72)
C
C
C
cr	glon=-185.		! TEC at glon=-180, -175,...0,5,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
	ddd=rx(k)
	da(28,k,ilat)=ddd  ! fof2 
	   enddo			  !<<<<<<<<<<<<<<<<<<<<<<<<<
  600	CONTINUE			  !< LAT-BY-LAT
  108	close(UNIT=110)
C
C
C Move data one day up: (1)	if(idy.lt.idy1)  (2) a
C
 	do ilat=1,71		  ! < LAT-BY-LAT
 	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				  !<day-by-day
      enddo                 ! all lati 
c//	if (idy.ge.idy1-6) ncnt=ncnt+1
	if ((jmn_pre.lt.12).and.(lday.ge.lda1-14)) ncnt=ncnt+1  ! during current year
	if ((jmn_pre.eq.12).and.(idy.ge.idy1-14)) ncnt=ncnt+1 ! transition from year-to-year
		if (ncnt.lt.15) goto 499
C
C
C Calculations for  day=idy: da(28,long,lat)
C	
  240	outfile(22:23)=ady	  !*************************************************
C++
      lda=ndoy(iyr,imn,idy) ! function to define day-of-year
	 	lda2=ndoy(iyr,imn,idy2) ! function to define day-of-year
C
		OPEN(112,FILE=OUTFILE)
C??	OPEN(113,FILE=OUTFILED)
C??	OPEN(114,FILE=OUTFILEM)
C??	OPEN(115,FILE=OUTFILESN)
C??	OPEN(116,FILE=OUTFILESP)
C
C  VERIFICATION OF MEDIAN	FOR TEC_MAP(long,lat) for one day (28)
  115 CONTINUE
C     LDNR=27
C       LDY1=21  ! for 7 prec days median
cc---       LDY1=21  ! for 7 prec days median
c
      DO 150 ilat=1,71			  ! Cycle on lati
C
C Median and STD1, STD2 calculation:
C
	DO MM=0,72	
C Prepare common array for -14 prec days, CC(15,0:72), for median and STD calculation:
C     DA(0:28,0:72,35) ! TEC -14 prec_days+curr_day=8,longs=0:72,lats=35

	DO kk=13,27
	kmed=kk-12
	CC(kmed,mm)=da(kk,mm,ilat)
	ENDDO	   ! cycle kk

	ENDDO      !cycle mm
	ndays=15
	nlons=72
c	call smedstd3(ndays,nlons) ! SMED(0:72),STD(0:72),STD1=neg(0:72),STD2=pos(0:72)
Ctemp	if ((iut.eq.17).and.(ilat.eq.15)) pause ' ' 
	CALL smedstd3(CC,SMED,STD,STD1,STD2)  ! Med. for 15 prec. days
        DO 144 M=0,72				  ! cycle on longi
CC      xpar=da(28,m,ilat) ??
	apar=da(27,m,ilat)  !TEC
	amed=smed(m)		   !TECmed
Cnorm	astd=STD(m)
Cnorm	astd1=std1(m)
Cnorm	astd2=std2(m)
C Calculation of Rs index for idy (27th line of days)
Cnorm	if (astd.gt.0.) then
Cnorm	call rfindex2(apar,amed,astd1,astd2,arat,irs)
Cnorm	else
Cnorm	arat=0.
Cnorm	irs=0
Cnorm	endif
C
      	call windex(apar,amed,delog,irs)
      XMED(M,ilat)=SMED(m)  ! foF2med
c/	x1=alog10(apar)
c/ 	x2=alog10(amed)
c/	delog=x1-x2

CREM	DEV(m,ilat)=ARAT
CREM	IRES(m,ilat)=iwind
CREM		IRES(m,ilat)=nint(delog*1000.)
C Sigma STD:
C	sigma=sqrt((astd1**2*7+astd2**2*7)/14.)
Cnorm	irat(m,ilat)=nint(ARAT*100.)         
Cnorm	istdn(m,ilat)=nint(ASTD1*10.)         
Cnorm	istdp(m,ilat)=nint(ASTD2*10.)         
Cnorm	imed(m,ilat)=nint(amed*10.)  
			IRES(m,ilat)=irs  !W(TEC) index
 144  CONTINUE        ! cycle M ~ glong

C	WRITE(*,498) (IRES(K,ilat),K=0,72)		!Temp
 	WRITE(112,498) (IRES(K,ilat),K=0,72)  ! W index
c- 	WRITE(*,498) (IRAT(K,ilat),K=0,72)
C?? 	WRITE(113,498) (IRAT(K,ilat),K=0,72)  !  (TEC-TECmed)/STD1 or STD2
c- 	WRITE(*,498) (IMED(K,ilat),K=0,72)
C?? 	WRITE(114,498) (IMED(K,ilat),K=0,72)  ! Med*10
c- 	WRITE(*,498) (ISTDN(K,ilat),K=0,72)		!Temp
C?? 	WRITE(115,498) (ISTDN(K,ilat),K=0,72)  ! STDn index
c- 	WRITE(*,498) (ISTDP(K,ilat),K=0,72)		!Temp
C?? 	WRITE(116,498) (ISTDP(K,ilat),K=0,72)  ! STDp index

C		 
 150	continue         ! cycle ilat
C
C END OF MEDIAN_TECxhi_MAP FOR DAY idy(28)
C ------------------------------------------------------
C output w-index map	
C					  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cr      DO ilat=1,35
cr	WRITE(*,498) (IRES(K,ilat),K=0,72)
cr	WRITE(112,498) (IRES(K,ilat),K=0,72)
cr	ENDDO
 498  FORMAT(73(1X,I4))
	CLOSE(unit=112)
C??		CLOSE(unit=113)
C??		CLOSE(unit=114)
C??		CLOSE(unit=115)
C??		CLOSE(unit=116)
C

C
	 ncnt=14
      goto 499		  ! to the next day processing
C	  						  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C =========================================
  500 continue   ! end day-by-day cycle     !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C-	imn=imni
	write(*,*) ' UT=',iut
  300 CONTINUE		! end UT cycle
C-   	call subprobfw(jp,AYR,AMN,IDYS,IDYS2)
  155 continue   ! end monthly cycle

c+ Wfp-index:
C-      	call subwfp3n(jp,AYR,AMN,IDYS,IDYS2)
C-	imn=imn+1
C-	if (imn.lt.13) goto 1333
      GOTO 102
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
    5	iend=1
  102	continue
            write(*,*) ' yr=',AYR,'  mn=',AMN,' dy1=',idy1,' dy2=',idy2 
Cnorm	if (imn.lt.12) GOTO 1333
	pause ' ' 
	goto 333
      STOP
	END
