      subroutine mapionexv1x1(fhts,ayear,amn,ady)
C..........................................Jan 2023
C produce diurnal results in formal JPL_IONEX 1x1 format 
C          for given YR, MN, DY, UT=0000,0015,0030,0045,0100,...,2345
C
	CHARACTER*65 INFILE,OUTFILE
	CHARACTER*2 AYR,AMN,ADY,AUT,AMM,CMN,amap
	CHARACTER*4 AYEAR
	CHARACTER*1 fhts ! DeltaTEC =t, v=Vsigma(tec) 
	CHARACTER*20 start,enddesc,epoch
        CHARACTER*60 title1(16),tit1,tit2,tit3
	CHARACTER*20 title2(16),utend
c/	character*80 txt1(180,22)
c/	character*40 txt5(180)
	CHARACTER*3 doy
	dimension im(12),ivs(180,360)
C
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
      DATA title1/
     + '     1.0            IONOSPHERE MAPS     GNSS                '
	+,'NETCDF2IONEX        JPL (IZMIRAN)       2022-12-18 07:11:54 '
	+,'JPL/IZMIRAN 15-min resolution GIM-Vs(TEC) map               '
	+,'Produced from JPLI GPS TEC IONEX MAP 1x1 grid               '
	+,'Contact:gulyaeva@izmiran.ru                                 '
	+,'  2015     3    18     0     0     0                        '
	+,'  2015     3    18    23    45     0                        '
	+,'   900                                                      '
	+,'    96                                                      '
	+,'     2                                                      '
	+,'   450.0 450.0   0.0                                        '
	+,'    89.5 -89.5  -1.0                                        '
	+,'  -179.5 179.5   1.0                                        '
	+,'    -1                                                      '
	+,'V values in index units, i.u. Hours, UT.                    '
     +,'                                                            '/
      tit1=title1(16)
      tit2=tit1
      tit3=tit1
      DATA title2/
     + 'IONEX VERSION / TYPE','PGM / RUN BY / DATE '
	+,'DESCRIPTION         ','DESCRIPTION         '
	+,'DESCRIPTION         ','EPOCH OF FIRST MAP  '
	+,'EPOCH OF LAST MAP   ','INTERVAL            '
     +,'# OF MAPS IN FILE   ','MAP DIMENSION       '
     +,'HGT1 / HGT2 / DHGT  ','LAT1 / LAT2 / DLAT  '
     +,'LON1 / LON2 / DLON  ','EXPONENT            '
     +,'COMMENT             ','END OF HEADER       '/
C
C
C
      start='START OF TEC MAP    '
	enddesc='END OF HEADER       '
	epoch='EPOCH OF CURRENT MAP'
      utend='END OF TEC MAP      ' 
C
C
write(*,*) AYEAR
		ayr=ayear(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
	read(ayear,*) xyear
	IYYYY=int(xyear)
	read(ayr,*) ryr
	iyr=int(ryr)
	write(*,*) amn
	CMN=AMN
	if (CMN(1:1).eq.'0') CMN(1:1)=' '
	read(amn,*) xmn
	imn=int(xmn)
c	rmon=tmon(imn)

C
		idayy=365
	      IM(2)=28
        if(iyr/4*4.eq.iyr) then
	  idayy=366
	   	 IM(2)=29
	  endif

	read(ady,*) xdy
	idy=int(xdy)
	lda=ndoy(iyr,imn,idy)
	call blet3(lda,doy)
c
c+	infile='d:\web\del\YR\MN\trMNDDUTMM.jYR'
	infile='d:\web\drs\YR\MN\vsMNDDUTMM.jYR'

C+    outfile='d:\web\del\YR\jpliDDD0.YRi'
      outfile='d:\web\drs\YR\jpliDDD0.YRi'
C
C	
		if (fhts.eq.'t') then
		infile(9:10)='el'
		infile(18:19)='tr'
	outfile(9:10)='el'
	outfile(18:18)='i'
		endif      
C	
		if (fhts.eq.'v') then
		infile(9:10)='rs'
		infile(18:19)='vs'
	outfile(9:10)='rs'
	outfile(18:18)='i'
		endif      
C	
	infile(12:13)=AYR
		infile(15:16)=AMN
		infile(20:21)=AMN
		infile(22:23)=ADY
		infile(30:31)=AYR
	
	outfile(12:13)=AYR
	outfile(19:21)=doy
      outfile(24:25)=AYR

	OPEN(10,file=outfile)
C
C write title lines
C
	DO nn=1,16
	tit1=title1(nn)
	if (nn.eq.2) then
	tit1(41:44)=AYEAR
	tit1(46:47)=AMN
	tit1(49:50)=ADY
	endif
	if ((nn.eq.6).or.(nn.eq.7)) then
	tit1(3:6)=AYEAR
	tit1(11:12)=CMN
	tit1(17:18)=ADY
	endif
	write(*,202) tit1,title2(nn)
	write(10,202) tit1,title2(nn)
	ENDDO
  202 format(A60,A20)
  107 format(22(A80),A40)
 1071 format(A80)
 1072 format(A40)
 1073 format(3X,F5.1,'-179.5 179.5   1.0 450.0',28X
     +,'LAT/LON1/LON2/DLON/H')
C
      tit3(3:6)=AYEAR
	tit3(11:12)=AMN
	tit3(17:18)=ADY
	tit3(35:36)='00' ! sec
C
C cycle	UT
C
         imap=0
        DO 100 iut=0,23
	call blet2(iut,AUT)
C
C
	tit3(23:24)=AUT
		infile(24:25)=AUT
C
C Cycle MIN
C
	DO 101 imm=0,45,15
	call blet2(imm,AMM)
	tit3(29:30)=AMM ! min

C
		imap=imap+1
 	call blet2(imap,amap)
	tit2(5:6)=AMAP

	write(*,202) tit2,start
	write(10,202) tit2,start
C
	write(*,202) tit3,epoch
	write(10,202) tit3,epoch
C
		infile(26:27)=AMM
	OPEN(11,file=infile,action='READ')
C =========================================
  170 FORMAT(360(2X,I3))
  171 FORMAT(20(2X,I3))
  172 FORMAT(8(2X,I3))
c
	do i=1,180
	i1=181-i
C//	READ (11,107,END=99,ERR=2) (TXT1(i1,k),k=1,20),txt5(i1) !map lines LATi(180)=(-89.5),...,LATI(1)=(+89.5)
      	READ (11,170,END=99,ERR=2) (ivs(i1,k),k=1,360)
	do k=1,360
	ivs(i1,k)=ivs(i1,k)*10 ! scale Vs*10
	enddo
	enddo
	glat=90.5
	DO i=1,180
	glat=glat-1.0
C	write(*,1073) glat	  !Temp
	write(10,1073) glat
	   do kk=1,22
	   k1=(kk-1)*16+1
C	   write(*,171) (ivs(i,k),k=k1,k1+15)
	   write(10,171) (ivs(i,k),k=k1,k1+15)
	   enddo
C	  write(*,172) (ivs(i,k),k=353,360)
	write(10,172) (ivs(i,k),k=353,360)
C//	write(10,1071) TXT1(i,kk)
	ENDDO
C//	write(10,1072) TXT5(i)
  99	close(unit=11)
C
C Write 'END OF TEC MAP'
		write(*,202) tit2,utend
		write(10,202) tit2,utend
  101	continue   ! end Min cycle
  100	continue   ! end ut cycle
        close(unit=10)
       GOTO 33
c==	endif
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
      write(*,*) infile,outfile
   34  RETURN
       END
