      program ptsealandq
C................................................June 2016
C Include weight Q for dependence of cell area on glats
C
C Extract pTEC map : pjMN00LT.hyr (J2) ; piMN00LT.hyr (IRI-Plas-CCIR)
C                     
C geogr.coords. IONEX grids 
C 
C Output: pTECave(sea) and pTECave(land) monthly mean for LT=00, 01,...,23
C
C ...............................................Jan. 2013
C extract from JPL-TEC map 
C
	CHARACTER*2 AYR,AMN,RLT
	CHARACTER*4 AYEAR
	CHARACTER*65 outfile0,outfile1,infile	! 0 ~ sea, 1 ~ land
	CHARACTER*1 ji
C	INTEGER*2 jyr,jmn
	logical lout
	DIMENSION tec(0:72),res0(12),res1(12),Q(71) ! weights*10
C
      DATA Q/.0067443,.0134533,.0201528,.0268159,.0334247,.0399717,
	+ .0464414,  .0528289,  .0591099,  .0652797,  .0713261,  .0772395,
	+ .0830030,  .0886092,  .0940534,  .0993114,  .1043856,  .1092541,
	+ .1139244,  .1183770,  .1225998,  .1265905,  .1303368,  .1338486,
	+ .1370943,  .1400788,  .1428022,  .1452546,  .1474168,  .1493105,
	+ .1509128,  .1522346,  .1532637,  .1539977,  .1544452,  .1545900,
	+ .1544452,  .1539977,  .1532637,  .1522346,  .1509128,  .1493105,
	+ .1474168,  .1452546,  .1428022,  .1400788,  .1370943,  .1338486,
	+ .1303368,  .1265905,  .1225998,  .1183770,  .1139244,  .1092541,
	+ .1043856,  .0993114,  .0940534,  .0886092,  .0830030,  .0772395,
	+ .0713261,  .0652797,  .0591099,  .0528289,  .0464414,  .0399717,
	+ .0334247,  .0268159,  .0201528,  .0134533,  .0067443/
C 
  	nn=1

	outfile0='ptseamn0.txt'
	outfile1='ptlanmn1.txt'
	OPEN(10,file=outfile0,access='APPEND')
	OPEN(11,file=outfile1,access='APPEND')

C Read geogr. coords.
  102	format(73(1X,F4.2))
  101	format(1X,A2,4(1X,F6.2))
  103	format(1X,A4,1X,A1)
C
  111	write(*,*) 'enter AYEAR='
	read(*,*) AYEAR
	AYR=AYEAR(3:4)

	write(*,*) 'enter j, i, t  or 0 for stop:'
	read(*,*) ji
	if (ji.eq.'0') goto 23   ! stop
C
	write(10,103) AYEAR,ji
	write(11,103) AYEAR,ji
C//      infile='hmMN0012.uYR'	  !SMF2 UT map
            infile='d:\web\dtc\YR\MN\pjMN00LT.hYR'
	infile(19:19)=ji
	infile(12:13)=AYR
	infile(28:29)=AYR
C Cycle on LT:
      DO 115 lt=0,23
	call blet2(lt,RLT)
      infile(24:25)=RLT
	do i=1,12
	res0(i)=0.
	res1(i)=0.
	enddo

C Cycle on mn:
	DO jmn=3,12,3
	call blet2(jmn,AMN)
	infile(15:16)=AMN
	infile(20:21)=AMN
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
C
	tecmn0=0.
	tecmn1=0.
C
C       
	OPEN(12,file=infile,action='READ')
C
C All lats 
	glat=-90.0
	cnt0=0.
	cnt1=0.
  110	DO 100 ilat=1,71
	glat=glat+2.5
	read(12,102,end=51,err=23) (tec(k),k=0,72) 
C
	glon=-185.
      	DO 77 ilon=0,72 	   !>>>>>>>>>>>>
	glon=glon+5.0
	if (glon.lt.0.) glon=glon+360.
C
	if (tec(ilon).lt.0.) goto 77
	call sealand(glat,glon,lout)
	if (lout) then
C=	tecmn0=tecmn0+tec(ilon) ! sea
	tecmn0=tecmn0+tec(ilon)*Q(ilat)*10. ! sea
C=	cnt0=cnt0+1.
	cnt0=cnt0+Q(ilat)*10.
	          else
C=	tecmn1=tecmn1+tec(ilon) ! land
	tecmn1=tecmn1+tec(ilon)*Q(ilat)*10. ! land
C=	cnt1=cnt1+1.
      cnt1=cnt1+Q(ilat)*10.
	endif
   77	CONTINUE  ! End cycle on ilon
C
  100	continue ! End cycle on ilat
   51 close(unit=12)
c	write(*,*) ' DAY =',ADY
c	cnt0=cnt1*24.*jdy2
c	cnt1=cnt1*24.*jdy2
C-	cnt0=3226.*24.*float(jdy2)
c-	cnt1=1957.*24.*float(jdy2)
CREM	cnt0=3226. ! total sea grids
CREM	cnt1=1957. ! total land grids
	res0(jmn)=tecmn0/cnt0
	res1(jmn)=tecmn1/cnt1
	  ENDDO                ! end month-to-month cycle
	write(*,101)  RLT,res0(3),res0(6),res0(9),res0(12)
	write(10,101) RLT,res0(3),res0(6),res0(9),res0(12)
	write(*,101)  RLT,res1(3),res1(6),res1(9),res1(12)
	write(11,101) RLT,res1(3),res1(6),res1(9),res1(12)
  115	CONTINUE        ! End cycle on LT

	 goto 111
   23	write(*,*) AYR,AMN
	close(unit=10)
	close(unit=11)
   	pause ' '
	stop
	end