      subroutine subexmag1j(ayr,amn,ij)
C................................................May 2016
C
C................................................Nov 2015
C Produce TEC-map in magnetic coordinated from GIM-TEC
C
C Extract JPL TEC map for maglat=-87.5,-85,...,85,87.5  (71 lines)
C                         maglon=0, 5, 10, ..., 355, 360 (0:72 columns)
C Input: <glatgrid1.txt> <glongrid1.txt> =geogr.coords. for mlat,mlon grids
C 
C infile <piMN00LT.hYR> ij='i' = IRI-Plas-CCIR map (Irina) 
C infile <pjMN00LT.hYR> ij='j' = Jason-2 map		 (Irina)
C infile <ptMN00LT.hYR> ij='t' = IRI-Plas-TECfit map
C infile <pcMN00LT.hYR> ij='c' = NeQ-Plas-CCIR map
C outfile '99' => '00' geomagn. coords
C ...............................................Jan. 2013
C extract-interpolate from JPL-TEC or UPC-TEC map 
C
	CHARACTER*2 AYR,AMN,AUT
	CHARACTER*1 ij
	CHARACTER*65 outfile,infile
C	+,inglats,inglons
c-	INTEGER*2 jyr,jmn,jdy,jut
C=	+,jdy1,jdy2
	DIMENSION im(12),itec(0:72)
	+,glats(71,0:72),glons(71,0:72),fhdat(71,0:72)
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	common/BLMAG/glats,glons
C
204	format(73(1X,F4.0))
  103	nn=1
C Read geogr. coords. for magn. grids
c	inglats='glatgrid1.txt'
c	inglons='glongrid1.txt'
  102	format(73(1X,I4))
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
	jmn=int(rmn)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF

c	jdy1=01
c	jdy2=im(jmn)
c	read(ady,*) jdy
C	jdy2=jdy1
C
C      infile='piMN00LT.iyr'
      infile='d:\web\dtc\YR\MN\piMN00LT.hyr'	! monthle LT maps in geogr, coords
	infile(19:19)=ij
	infile(12:13)=AYR
	infile(15:16)=AMN
      infile(20:21)=AMN
	infile(28:29)=AYR
C       
C Cycle on LT
	do 115 jlt=0,23
	call blet2(jlt,AUT)
	infile(24:25)=AUT

C	pTECobs in magn.coord. IONEX grids
		outfile=infile
	outfile(22:23)='99'		!  outfile in magn coords pimn99LT.hyr 
	OPEN(13,file=outfile)
	OPEN(14,FILE=INFILE,action='READ')
			do ilat=1,71
 	read(14,204) (fhdat(ilat,k),k=0,72)	
	enddo
	close(unit=14)
 
C
C All Mlats 
  110	DO 100 ilat=1,71
      	DO ilon=0,72 
	glat=glats(ilat,ilon)
	glon=glons(ilat,ilon)
C
C
C??	call subinterp3(fm,glat,glon,ayr,amn,ady,aut,res)
C
C      interpolate for glat,glon
C Linear Interpolation   
	aglat=-90.
	do 161 lat=1,70 ! select pair of lats-lines (k) & (k+1)
c	aglat=-87.5,-85,...,87.5
	aglat=-90.+2.5*lat
	aglat2=aglat+2.5
C
	if ((glat.ge.aglat).and.(glat.le.aglat2)) then  !   <<<<1
C Select pair of longs embracing glong
	 clon=-185.
	along=glon  ! geogr. glon at mlong grid
	if (along.ge.180.) along=along-360.0
	do j=0,71 ! select pair of longs (j) & (j+1)
	clon=clon+5.
	clon2=clon+5.
	if ((along.ge.clon).and.(along.lt.clon2)) then  ! +++2
	res11=fhdat(lat,j)
	res12=fhdat(lat,j+1)
	res21=fhdat(lat+1,j)
	res22=fhdat(lat+1,j+1)
	if ((res11.lt.0.).or.(res12.lt.0.).or.(res21.lt.0.).or.
	+(res22.lt.0.)) then							 ! J2 data are absent:
	res=-100.
	exit
	endif
	res1=res11+(res12-res11)/5.*(along-clon)
	res2=res21+(res22-res21)/5.*(along-clon)
	res=res1+(res2-res1)/2.5*(glat-aglat)
	endif											 ! +++2
	enddo	! end select pair of longs (j) & (j+1)
	exit
	endif											 !   <<<<1
  161 continue		   ! interpolation end
	itec(ilon)=nint(res)
	   ENDDO
	write(*,102) (itec(k),k=0,72)
	write(13,102) (itec(k),k=0,72)

C
  100	continue ! End cycle on ilat
	close(unit=13)
Crem	write(*,*) ' UT=',AUT

  115	CONTINUE        ! End cycle on LT
c	write(*,*) ' DAY =',ADY
	
  120	CONTINUE        ! End day-to-day cycle
	write(*,121) ayr,amn
  121	format(1X,A2,1X,A2)
c   	pause ' '
   23	RETURN
crem	stop
	end