      subroutine subinterpt1x1(glat,glon,syr,smn,sdy,sut,smm,res)
C.................................................................Jan. 2023
C Gulyaeva Tamara <gulyaeva@izmiran.ru>
C
C Subroutine to interpolate data from IONEX maps (TEC) 1x1 grids
C Input : 
C		fm='t' means TEC
C         glat - geographic latitute
C         glon - geographic longitude
C         syr - YEAR = '99' for 1999,'00' for 2000, etc.
C         smn - month
C         sdy - day of month
C         sut - hour, UT
C         smm - minutes 00,15,30,45
C.................................................................
C Outpur : res - value of TEC (0.1TECU)
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc,tc interpolated from directories dfc, dhc, dtc maps - update addresses for input file
C
	DIMENSION fhdat(0:359,180)	  ! maps TEC
	CHARACTER*1 fm
	CHARACTER*2 syr,smn,sdy,sut,smm
c-	CHARACTER(10) DDDD
c-	CHARACTER*4 TIMC 
c-	CHARACTER(5) ZZZ
      CHARACTER*45 infilet
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc predictions from directories dfs, dhs
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	fm='t'   ! TEC
	read(syr,*) ryr
	iyr=int(ryr)
	read(sdy,*) rdy1
	 ndy1=int(rdy1)
	read(smn,*) rmn1
	imn1=int(rmn1)
C Use fc,hc predictions from directories dfc or dhc
C	infilef='d:\web\graf\dfc\YR\MN\ut\fcMNDDUT.jYR' ! path and name of input file JPL
	infilet='d:\web\dtt\YR\MN\tiMNDDUTMM.jYR' ! input GIM-TEC 1x1
	infilet(12:13)=SYR
	infilet(15:16)=SMN
	infilet(30:31)=SYR
	infilet(20:21)=SMN
	infilet(22:23)=sdy
	infilet(24:25)=sut
	infilet(26:27)=smm
 204	format(360(1X,F4.0))
C
	OPEN(10,FILE=INFILET,action='READ')		

		do ilat=1,180
	read(10,204) (fhdat(k,ilat),k=0,359)	
	enddo
	close(unit=10)
C
C      interpolate for glat,glon
C Linear Interpolation   
C--	aglat=-90.
	res=0.
	res11=0.
	res12=0.
	res21=0.
	res22=0.
	do 161 ilat=1,179 ! select pair of lats-lines (k) & (k+1)
c	aglat=-87.5,-85,...,87.5
	aglat=-90.5+ilat
	aglat2=aglat+1.0
C
	if ((glat.ge.aglat).and.(glat.le.aglat2)) then  !   <<<<1
C Select pair of longs embracing glong
	 clon=-180.5
	along=glon
	if (along.ge.180.) along=along-360.0
	do j=0,358 ! select pair of longs (j) & (j+1)
	clon=clon+1.
	clon2=clon+1.
	if ((along.ge.clon).and.(along.le.clon2)) then  ! +++2
	res11=fhdat(j,ilat)
	res12=fhdat(j+1,ilat)
	res21=fhdat(j,ilat+1)
	res22=fhdat(j+1,ilat+1)
	res1=res11+(res12-res11)*(along-clon)
	res2=res21+(res22-res21)*(along-clon)
	res=res1+(res2-res1)*(glat-aglat)
	endif											 ! +++2
	enddo	! end select pair of longs (j) & (j+1)
	exit
	endif											 !   <<<<1
  161 continue		   ! interpolation end
	close(unit=10)
	res=res/10.0      !TECU
	RETURN
	END