      subroutine subinterpv1x1(glat,glon,syr,smn,sdy,sut,smm,ires)
C.................................................................Jan. 2023
C Gulyaeva Tamara <gulyaeva@izmiran.ru>
C
C Subroutine to interpolate data from IONEX maps (W-index weights) 1x1 grids
C Input : fm='v' means Vsigma from GIM-Vsigma JPL file
C         glat - geographic latitute
C         glon - geographic longitude -179.5:1:179.5
C         syr - YEAR = '99' for 1999,'00' for 2000, etc.
C         smn - month
C         sdy - day of month
C         sut - hour, UT
C         smm - minute 00,15,30,45
C.................................................................
C Output : res - value of TEC (0.1TECU)
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc,tc interpolated from directories dts maps - update addresses for input file
C
	DIMENSION idat(0:359,180),weg(4)	  ! maps fcF2,hcF2,TEC
	CHARACTER*1 fm
	CHARACTER*2 syr,smn,sdy,sut,smm
      CHARACTER*45 infilev
	DATA WEG/0.,0.6931,1.0986,1.3863/  ! =ln1, ln2, ln3, ln4
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	fm='v'   ! Vsigma .jYR file
	read(syr,*) ryr
	iyr=int(ryr)
	read(sdy,*) rdy1
	 ndy1=int(rdy1)
	read(smn,*) rmn1
	imn1=int(rmn1)
C 
C-	infilef='d:\web\graf\dwc\YR\MN\ut\wcMNDDUT.jYR' ! input GIM-W
	infilev='d:\web\drs\YR\MN\vsMNDDUTMM.jYR' ! input GIM-Vsigma
	infilev(12:13)=SYR
	infilev(15:16)=SMN
	infilev(30:31)=SYR
	infilev(20:21)=SMN
	infilev(22:23)=sdy
	infilev(24:25)=sut
	infilev(26:27)=smm
 204	format(360(1X,I4))
C
	OPEN(10,FILE=INFILEV,action='READ')		

		do ilat=1,180
	read(10,204) (idat(k,ilat),k=0,359)	
	enddo
	close(unit=10)
C
C      interpolate for glat,glon
C Linear Interpolation   
C--	aglat=-180.5
	swe=0.
	icnt=0
	res=0.
	res11=0.
	res12=0.
	res21=0.
	res22=0.
	do 161 ilat=1,179 ! select pair of lats-lines (k) & (k+1)
c	aglat=-87.5,-85,...,87.5
	aglat=-90.5+ilat
	aglat2=aglat+1.0
C
	if ((glat.ge.aglat).and.(glat.le.aglat2)) then  !   <<<<1
C Select pair of longs embracing glong
      elat= 1.0+0.0001235*aglat**2	  ! AD
	elat2= 1.0+0.0001235*aglat2**2	  ! AD
	 clon=-180.5
	along=glon
	if (along.ge.180.) along=along-360.0
	do j=0,358 ! select pair of longs (j) & (j+1)
	clon=clon+1.0
	clon2=clon+1.0
	if ((along.ge.clon).and.(along.lt.clon2)) then  ! +++2
C+	iad=idat(j,ilat)
C Select nearest Vs index:
	dlon1=along-clon
	dlon2=clon2-along
	if (dlon1.lt.dlon2) then
	klon=j
	                   else
	klon=j+1
	endif
	dlat1=glat-aglat
	dlat2=aglat2-glat
	if (dlat1.lt.dlat2) then
	klat=ilat
	else
	klat=ilat+1
	endif
	ires=idat(klon,klat)
	exit
C Avoid weighted indices============================>
	if (iad.gt.1) then
	res11=elat*weg(iad)*iad
	icnt=icnt+1
	endif
	iad=idat(j+1,ilat)
	if (iad.gt.1) then
	res12=elat*weg(iad)*iad
	icnt=icnt+1
	endif
      iad=idat(j,ilat+1)
	if (iad.gt.1) then
	res21=elat2*weg(iad)*iad
	icnt=icnt+1
	endif
      iad=idat(j+1,ilat+1)
	if (iad.gt.1) then
	res22=elat2*weg(iad)*iad
	icnt=icnt+1
	endif
C
	iad=idat(j,ilat)
	if (iad.lt.-1) then
	res11=elat*weg(-iad)*iad
	icnt=icnt+1
	endif
	iad=idat(j+1,ilat)
	if (iad.lt.-1) then
	res12=elat*weg(-iad)*iad
	icnt=icnt+1
	endif
      iad=idat(j,ilat+1)
	if (iad.lt.-1) then
	res21=elat2*weg(-iad)*iad
	icnt=icnt+1
	endif
      iad=idat(j+1,ilat+1)
	if (iad.lt.-1) then
	res22=elat2*weg(-iad)*iad
	icnt=icnt+1
	endif
C
	res1=res11+(res12-res11)*(along-clon)
	res2=res21+(res22-res21)*(along-clon)
	res=res1+(res2-res1)*(glat-aglat)
	endif											 ! +++2
	enddo	! end select pair of longs (j) & (j+1)
	exit
	endif											 !   <<<<1
  161 continue		   ! interpolation end
	close(unit=10)
	RETURN
	END