      subroutine subinterpw1(glon,syr,smn,sdy,sut,iad)
C.................................................................Oct. 2022
C Gulyaeva Tamara <gulyaeva@izmiran.ru>
C
C Subroutine to interpolate data from IONEX maps (W-index weights)
C Input : fm='w' means Wc from GIM-W JPL file
C         glat - geographic latitute
C         glon - geographic longitude
C         syr - YEAR = '99' for 1999,'00' for 2000, etc.
C         smn - month
C         sdy - day of month
C         sut - hour, UT
C.................................................................
C Output : res - value of TEC (0.1TECU)
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc,tc interpolated from directories dts maps - update addresses for input file
C
	DIMENSION idat(0:72,71),iad(71)
C--	+,weg(4)	  ! maps fcF2,hcF2,TEC
	CHARACTER*1 fm
	CHARACTER*2 syr,smn,sdy,sut
      CHARACTER*45 infilef
C--	DATA WEG/0.,0.6931,1.0986,1.3863/  ! =ln1, ln2, ln3, ln4
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	fm='w'   ! wc .jYR file
	read(syr,*) ryr
	iyr=int(ryr)
	read(sdy,*) rdy1
	 ndy1=int(rdy1)
	read(smn,*) rmn1
	imn1=int(rmn1)
C 
	infilef='d:\web\graf\dwc\YR\MN\ut\wcMNDDUT.jYR' ! input GIM-W
	infilef(17:18)=SYR
	infilef(20:21)=SMN
	infilef(36:37)=SYR
	infilef(28:29)=SMN
	infilef(30:31)=sdy
	infilef(32:33)=sut
 204	format(73(1X,I4))
C
	OPEN(10,FILE=INFILEF,action='READ')		

		do ilat=1,71
	read(10,204) (idat(k,ilat),k=0,72)	
	enddo
	close(unit=10)
C
C      interpolate for glat,glon
C Linear Interpolation   
	aglat=-90.
	swe=0.
	icnt=0
	res=0.
	res11=0.
	res12=0.
	res21=0.
	res22=0.
C Long cycle
       clon=-185.0
	DO 160 ilon=0,72
	clon=clon+5.0
	clon2=clon+5.
	along=glon
	if (along.ge.180.) along=along-360.0
	if ((along.ge.clon).and.(along.lt.clon2)) then  ! +++2
C
C lats cycle
	do 161 ilat=1,71 ! select pair of lats-lines (k) & (k+1)
C//	if ((glat.ge.aglat).and.(glat.le.aglat2)) then  !   <<<<1
	iad(ilat)=idat(ilon,ilat)  ! =W(along)
C
  161 continue		   ! glati end
	endif											 !   <<<<2
  160 continue		   ! interpolation end
	close(unit=10)
	RETURN
	END