      program sunxhi
C..............................................................Jan 2023
C
        character*32 outfile
              common/const/umr,pi     /const1/humr,dumr
C         DHOUR         LOCAL TIME (OR UNIVERSAL TIME + 25) IN DECIMAL 
C                          HOURS
        	pi=ATAN(1.0)*4.
        	UMR=pi/180.
        	humr=pi/12.
        	dumr=pi/182.5
	outfile='suxhi.txt'
	OPEN(10,file=outfile,access='APPEND')
C
        iyear=2023
	iyr=23
	imn=2
C+	write(*,*) ' Enter idy'
C+	read(*,*) idy
      idy=3
	lda=ndoy(iyr,imn,idy)
c       DHOUR=25. ! UT=0 Test
C
C CALCULATION OF UT/LT and XMLT  ...............
c
c        IF(DHOUR.le.24.0) then
c        	HOUR=DHOUR					! dhour =< 24 is LT
c            hourut=hour-longi/15.
c            if(hourut.lt.0) hourut=hourut+24.
c		else
c        	hourut=DHOUR-25.				 ! dhour>24 is UT+25
c        	hour=hourut+longi/15.	 		 ! hour becomes LT
c        	if(hour.gt.24.) hour=hour-24.
c        endif
C
        write(*,31) iyear
	write(10,31) iyear
  31  format(1X,I4,' imn idy  LT ut  glat glon  xhi3 sax300 sux300')
  32  format(1X,I2,1X,F6.2)
            DO 50 ihour=0,23
	HOUR=float(ihour)
C CALCULATION OF SOLAR ZENITH ANGLE (XHI/DEG),, SUN DECLINATION ANGLE 
C (SUNDEC), SOLAR ZENITH ANGLE AT NOON (XHINON) AND TIME OF LOCAL 
C SUNRISE/SUNSET (SAX, SUX; dec. hours) AT 300 KM 
C 
        glat=-90.5
          DO 51 ilat=1,180
	glat=glat+1.0
	write(*,32) ihour,glat
	alon=-180.5
	    DO 52 ilon=1,360
	alon=alon+1.0
	glon=alon
	if (glon.lt.0.) glon=glon+360.0
	ut=hour+alon/15.0
CC
C      PHI=pi
      SUNDEC=-0.40915*COS(2.0*PI/365.25*(LDA+8))
      Z1=SIN(SUNDEC)*SIN(GLAT*UMR)
      Z2=COS(SUNDEC)*COS(GLAT*UMR)
	 SUNDEC=SUNDEC/UMR
      IF (ABS(Z2).GT.0.0) GOTO 120
      SAX=24.0
      IF (Z1.GE.0.0) SAX=0.0
      GOTO 140
  120 IF (ABS(Z1/Z2).LE.1.0) GOTO 510
      SAX=24.0
      IF ((Z1+Z2).GE.0.0) SAX=0.0
      GOTO 140
  510 SAX=12.0-ACOS(-Z1/Z2)/(UMR*15.0)
  140 SUX=24.0-SAX
      XLSTA=15.0*(HOUR-12.0)
       IF(XHI.GT.(-10.0)) GOTO 520
      COSXHI=Z1+Z2*COS(XLSTA*UMR)
      XHI=ACOS(COSXHI)/UMR
	GOTO 503
  520 COSXHI=COS(XHI*UMR)
           
Cc
  503	    CALL SOCO(lda,HOUR,GLAT,GLON,300.,SDEC,XHI3,SAX300,SUX300)
	if (sax300.gt.24) then
	saxut=sax300
	else
	saxut=sax300+alon/15.
	endif
	if (sux300.gt.24) then
	suxut=sux300
	                else
	suxut=sux300+alon/15.
	endif
	if ((sax300.gt.24.).or.(sux300.gt.24.)) goto 52
	write(*,30) iyear,imn,idy,ihour,ut,glat,alon,xhi3,sax300,sux300
	+,saxut,suxut
	write(10,30) iyear,imn,idy,ihour,ut,glat,alon,xhi3,sax300,sux300
 	+,saxut,suxut
C
   52 continue
C
   51 continue
   50 continue
   30 format(1X,I4,3(1X,I2),1X,F6.2,2(1X,F6.1),1X,F6.2,4(1X,F6.2))
       pause ' '
	STOP
	END
C
C******************************************************************
C********** ZENITH ANGLE, DAY OF YEAR, TIME ***********************
C******************************************************************
C
C
        subroutine soco (ld,t,flat,Elon,height,
     &          DECLIN, ZENITH, SUNRSE, SUNSET)
c--------------------------------------------------------------------
c       s/r to calculate the solar declination, zenith angle, and
c       sunrise & sunset times  - based on Newbern Smith's algorithm
c       [leo mcnamara, 1-sep-86, last modified 16-jun-87]
c       {dieter bilitza, 30-oct-89, modified for IRI application}
c
c in:   ld      local day of year
c       t       local hour (decimal)
c       flat    northern latitude in degrees
c       elon    east longitude in degrees
c		height	height in km
c
c out:  declin      declination of the sun in degrees
c       zenith      zenith angle of the sun in degrees
c       sunrse      local time of sunrise in hours 
c       sunset      local time of sunset in hours 
c-------------------------------------------------------------------
c
        common/const/dtr,pi     /const1/humr,dumr
c amplitudes of Fourier coefficients  --  1955 epoch.................
        data    p1,p2,p3,p4,p6 /
     &  0.017203534,0.034407068,0.051610602,0.068814136,0.103221204 /
c
c s/r is formulated in terms of WEST longitude.......................
        wlon = 360. - Elon
c
c time of equinox for 1980...........................................
        td = ld + (t + Wlon/15.) / 24.
        te = td + 0.9369
c
c declination of the sun..............................................
        dcl = 23.256 * sin(p1*(te-82.242)) + 0.381 * sin(p2*(te-44.855))
     &      + 0.167 * sin(p3*(te-23.355)) - 0.013 * sin(p4*(te+11.97))
     &      + 0.011 * sin(p6*(te-10.41)) + 0.339137
        DECLIN = dcl
        dc = dcl * dtr
c
c the equation of time................................................
        tf = te - 0.5
        eqt = -7.38*sin(p1*(tf-4.)) - 9.87*sin(p2*(tf+9.))
     &      + 0.27*sin(p3*(tf-53.)) - 0.2*cos(p4*(tf-17.))
        et = eqt * dtr / 4.
c
        fa = flat * dtr
        phi = humr * ( t - 12.) + et
c
        a = sin(fa) * sin(dc)
        b = cos(fa) * cos(dc)
        	cosx = a + b * cos(phi)
        	if(abs(cosx).gt.1.) cosx=sign(1.,cosx)
        zenith = acos(cosx) / dtr
c
c calculate sunrise and sunset times --  at the ground...........
c see Explanatory Supplement to the Ephemeris (1961) pg 401......
c sunrise at height h metres is at...............................
		h=height*1000.
        chih = 90.83 + 0.0347 * sqrt(h)
c this includes corrections for horizontal refraction and........
c semi-diameter of the solar disk................................
        ch = cos(chih * dtr)
        cosphi = (ch -a ) / b
c if abs(secphi) > 1., sun does not rise/set.....................
c allow for sun never setting - high latitude summer.............
        secphi = 999999.
        if(cosphi.ne.0.) secphi = 1./cosphi
        sunset = 99.
        sunrse = 99.
        if(secphi.gt.-1.0.and.secphi.le.0.) return
c allow for sun never rising - high latitude winter..............
        sunset = -99.
        sunrse = -99.
        if(secphi.gt.0.0.and.secphi.lt.1.) return
c
        	cosx = cosphi
        	if(abs(cosx).gt.1.) cosx=sign(1.,cosx)
        phi = acos(cosx)
        et = et / humr
        phi = phi / humr
        sunrse = 12. - phi - et
        sunset = 12. + phi - et
        if(sunrse.lt.0.) sunrse = sunrse + 24.
        if(sunset.ge.24.) sunset = sunset - 24.
c special case sunrse > sunset
        if(sunrse.gt.sunset) then
        	sunx=sign(99.0,flat)
        	if(ld.gt.91.and.ld.lt.273) then
        		sunset = sunx
        		sunrse = sunx
        	else
        		sunset = -sunx
        		sunrse = -sunx
        	endif
        	endif
c
        return
        end
c
