      program taumap
C..............................................................May  2018
C
C..............................................................Aug. 2017
C Add producing GIM-Tau_global_mean => 'tauavYR.txt'
C Produce tau map in IONEX from JPL-GIM-TEC divided by PRIME_foF2_map
C Input:
C JPL GIM-TEC IONEX maps in geogr coords d:\web\dts\YR\MN\tcMNDYUT.jYR
C (1) PRIME foF2 IONEX maps in geogr coords d:\web\dfc\YR\MN\fcMNDYUT.pYR	
C (2) GIM_fcF2 derived by IRI-Plas from TEC-fit d:\web\dfs\YR\MN\fcMNDYUT.jYR	
c	  count Tau=TEC/NmF2, 
C (1) Output: tuMNDDUT.pYR => d:\web\dtt\YR\MN\	 !slab-thickness Tau_Prime map
C (2) Output: tsMNDDUT.jYR => d:\web\dtt\YR\MN\	 !slab-thickness Tau_TEC_fcF2 map
C Maps in geogr coord. glats -87.5:2.5:87.5 , Mlongs -180:5:180
C	   
      DIMENSION IM(12),TEC(0:72),FF2(0:72)
	+,TAUAV(0:23),ITAUAV(0:23) ! Tau-mean
	INTEGER*4 IRES(0:72)
	CHARACTER*128 INFILE1,INFILE2,OUTFILE,OUTMEAN
	CHARACTER*2 ayr,amn,ady,aut
	CHARACTER*4	AYMN,AYEAR
		CHARACTER*1 cc ! =p for PRIME, =c for TEC-fit fcF2
     +,fhts !
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Test
C==	outfile='d:\web\dtt\YR\MN\tumnddut.jYR'  !Tau from PRIME
	outfile='d:\web\dtt\YR\MN\tsmnddut.jYR'  !Tau from fcF2  TECfit SMI code in JPL_IONEX format
	infile1='d:\web\dts\YR\MN\tcmnddut.jYR'	 ! TEC
c==	infile2='d:\web\dfc\YR\MN\fcmnddut.pYR'  ! foF2
	infile2='d:\web\dfc\YR\MN\fcmnddut.jYR'  ! foF2
C	outmean='tauavYR.txt'
	outmean='tauavYRs.txt'

C 
CREM        WRITE(*,*)' ENTER cc (p=PRIME, c =fcF2-tec-fit):'
CREM		READ(*,14) cc
      cc='c' !TEMP    for JPL GIM_foF2
c==            cc='p' !TEMP  for PRIME_foF2 maps
	fhts='s' !Temp for tau map
   1        WRITE(*,*)' ENTER yrmn (0000=stop):'
		READ(*,15) AYMN
	      WRITE(*,*)' ENTER idy1, idy2 :'
		READ(*,*) idy1,idy2
	AYR=AYMN(1:2)
	outmean(6:7)=AYR

	OPEN(15,file=outmean,access='APPEND')  ! Tau mean
C
	AMN=AYMN(3:4)
   14	FORMAT(A1)
   15	FORMAT(A4)
	if (aymn.eq.'0000') goto 2	   ! Stop program
C
        if (cc.eq.'p') then
	outfile(27:27)=cc
	else
	infile2(10:10)='s'
	infile2(27:27)='j'
	endif

	AYEAR(3:4)=AYR
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.30) then
	iyyyy=2000+iyr
	AYEAR(1:2)='20'
	              else
	iyyyy=1900+iyr
	AYEAR(1:2)='19'
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
	infile1(12:13)=ayr
	infile1(28:29)=ayr
	infile2(12:13)=ayr
	infile2(28:29)=ayr
	outfile(12:13)=ayr
	outfile(28:29)=ayr
C
	outfile(15:16)=amn
	outfile(20:21)=amn
	infile1(15:16)=amn
	infile1(20:21)=amn
	infile2(15:16)=amn
	infile2(20:21)=amn
C
C=  200 continue
  199	format(A2)
C
C Day-to-day cycle
       read(AMN,*) rmn
	IMN=int(rmn)   ! current mn
       nmdy=im(imn)
C	DO 200 idy=1,nmdy
	DO 200 idy=idy1,idy2
	call blet2(idy,ADY)
	outfile(22:23)=ady
	infile1(22:23)=ady
	infile2(22:23)=ady
C
C  UT cycle
	DO 260 iut=0,23
	call blet2(iut,AUT)
	do kk=0,23
	tauav(kk)=0.
	enddo
C
	outfile(24:25)=aut
	infile1(24:25)=aut
	infile2(24:25)=aut
c     
	OPEN(11,FILE=INFILE1,action='READ')				  ! file TEC
	OPEN(12,FILE=INFILE2,action='READ')				  ! file foF2
	OPEN(13,FILE=OUTFILE)				  ! Tau
C
C=  201	continue
  159	format(73(1X,F4.1))
  162	format(73(1X,I4))
  163	format(1X,3A2,24(1X,I4))
C
C Cycle of lats:
      DO lat=1,71
    	read (11,159,end=300) (tec(k),k=0,72)      ! file TEC
      read (12,159,end=300) (ff2(k),k=0,72)      ! file foF2
	do 10 i=0,72
	 xnm=ff2(i)*ff2(i)*1.24
	rtau=tec(i)/xnm*1000.
	tauav(iut)=tauav(iut)+rtau
   11	 ires(i)=nint(rtau)
   10	continue
c	write(*,162) (ires(k),k=0,72)
	write(13,162) (ires(k),k=0,72)
       ENDDO !next lat
	itauav(iut)=nint(tauav(iut)/5183.)
C
  260	continue  ! next UT
	write(*,163) AYR,AMN,ADY,(itauav(k),k=0,23)
	write(15,163) AYR,AMN,ADY,(itauav(k),k=0,23)
C
C
  300	CONTINUE
	close(unit=11)
	close(unit=12)
	close(unit=13)
C Produce daily file in JPL IONEX format
	call mapionex(fhts,ayear,amn,ady)
  200	CONTINUE  ! next day
	if (imn.lt.13) goto 1
    2    write(*,*) infile1,infile2,outfile,outmean
      close(unit=15)
    	pause ' '
      STOP
	end