      program taumapreg
C..............................................................Feb. 2018
C Tau regional for au and eu maps
C Add producing GIM-Tau_global_mean => 'tauavYR.txt'
C Produce tau map in IONEX from JPL-GIM-TEC divided by PROME_foF2_map
C Input:
C JPL GIM-TEC IONEX maps in geogr coords d:\web\dts\YR\MN\tcMNDYUT.jYR
C (1) PRIME foF2 IONEX maps in geogr coords d:\web\dfc\YR\MN\fcMNDYUT.pYR	
C (2) GIM_fcF2 derived by IRI-Plas from TEC-fit d:\web\dfs\YR\MN\fcMNDYUT.jYR	
c	  count Tau=TEC/NmF2, 
C (1) Output: tuMNDDUT.pYR => d:\web\dtt\YR\MN\	 !slab-thickness Tau_Prime map
C (2) Output: tuMNDDUT.pYR => d:\web\dtt\YR\MN\	 !slab-thickness Tau_TEC_fcF2 map
C Maps in geogr coord. glats -87.5:2.5:87.5 , Mlongs -180:5:180
C	   
      DIMENSION IM(12),TEC(72),FF2(72)
C-	+,ITAU(72) ! regional array 
C/	+,TAUAV(0:23),ITAUAV(0:23) ! Tau-mean
	INTEGER*4 IRES(72)
	CHARACTER*128 INFILE1,INFILE2,OUTFILE,OUTMEAN
	CHARACTER*2 ayr,amn,ady,aut
	 CHARACTER*1 CC !=a for AU (R1), =e for EU(R2) or 
	CHARACTER*4	AYMN
	CHARACTER*24 txt
C//		CHARACTER*1 cc ! =p for PRIME, =c for TEC-fit fcF2
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Test
	outfile='d:\web\dtu\YR\MN\tumnddutRY.eYR'  !Tau	 for R1 or R2
	infile1='d:\web\dtt\YR\MN\ttmnddutRY.eYR'	 ! TEC for R1 or R2
	infile2='d:\web\graf\xum\yrmnddut.grd'  !foF2 for R1(dlat=2) or R2(dlat=1)
	outmean='tauavYYRY.txt'	  !for R1 or R2
C 
        WRITE(*,*)' ENTER cc (e=eu, a =au):'
		READ(*,14) cc
C      cc='a' !TEMP    for R1
   1        WRITE(*,*)' ENTER yrmn (9999=stop):'
		READ(*,15) AYMN
	if (aymn.eq.'9999') goto 2	   ! Stop program
	       WRITE(*,*)' ENTER IDY-start:'
		READ(*,*) idy0
C
	AYR=AYMN(1:2)
	AMN=AYMN(3:4)
C
        if (cc.eq.'a') then
	Y='1'
	X='a'
	else
	Y='2'
	X='e'
	endif
	outmean(9:9)=Y
	outmean(6:7)=AYR
	OPEN(10,file=outmean,access='APPEND')
	outfile(12:13)=AYR
	outfile(30:31)=AYR
		outfile(15:16)=AMN
	outfile(20:21)=AMN
	outfile(27:27)=Y
	infile1(12:13)=AYR
	infile1(30:31)=AYR
	infile1(15:16)=AMN
	infile1(20:21)=AMN
	infile1(27:27)=Y
	infile2(13:13)=X
	infile2(17:18)=AYR
	infile2(19:20)=AMN
C
   14	FORMAT(A1)
   15	FORMAT(A4)
C

	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.30) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C=  200 continue
  199	format(A2)
C
C Day-to-day cycle
       read(AMN,*) rmn
	IMN=int(rmn)   ! current mn
       nmdy=im(imn)
	DO 200 idy=idy0,nmdy
	call blet2(idy,ADY)
	outfile(22:23)=ady
	infile1(22:23)=ady
	infile2(21:22)=ady
C
C  UT cycle
	DO 260 iut=0,23
	call blet2(iut,AUT)
C
	outfile(24:25)=aut
	infile1(24:25)=aut
	infile2(23:24)=aut
c     
	OPEN(11,FILE=INFILE1,action='READ')				  ! file TEC
C
	OPEN(12,FILE=INFILE2,action='READ')				  ! file CBK foF2
	do i=1,5
	read(12,*) txt	! extra lines
	enddo
C
	OPEN(13,FILE=OUTFILE)				  ! Tau
C
C=  201	continue
  158	format(51(1X,F4.1))
  159	format(36(1X,F4.1))
  161	format(51(1X,I4))
  162	format(36(1X,I4))
  163	format(1X,4A2,1X,F7.1)
C
C Cycle of lats:
C
	IF (cc.eq.'a') THEN        !++++++++++++++++++++++++++++
C
C reg1 = au
	avr1=0.
	cnr1=0.
      DO lat=1,41                 ! LAT cycle
    	read (11,159,end=301) (tec(k),k=1,36)      ! file TEC
      read (12,*,end=302) (ff2(k),k=1,36)      ! file foF2
	do 10 i=1,36
	 xnm=ff2(i)*ff2(i)*1.24
	rtau=tec(i)/xnm*1000.
C
	if (rtau.lt.2000.) then
	avr1=avr1+rtau
	cnr1=cnr1+1.
	endif
C
	if ((rtau.lt.0.).or.(rtau.gt.1999.)) rtau=1999.
C/	tauav(iut)=tauav(iut)+rtau
   	 ires(i)=nint(rtau)
   10	continue
c	write(*,162) (ires(k),k=1,36)
	write(13,162) (ires(k),k=1,36)
       ENDDO !next lat	  ! LAT cycle
c	itauav(iut)=nint(tauav(iut)/5183.)
	taur1=avr1/cnr1
	write(*,303) AYR,AMN,ADY,AUT,taur1
	write(10,303) AYR,AMN,ADY,AUT,taur1
C
C	write(*,163) AYR,AMN,ADY,(itauav(k),k=0,23)
C	write(10,163) AYR,AMN,ADY,(itauav(k),k=0,23)
	                     else !++++++++++++++++++++++++++++++++
C reg2 = eu
	avr2=0.
	cnr2=0.
      DO lat=1,18                 ! LAT cycle eum
    	read (11,158,end=301) (tec(k),k=1,51)      ! file TEC
      read (12,*,end=302) (ff2(k),k=1,51)      ! file foF2
C	if (lat/2*2.ne.lat) then ! exclude odd lines
	read (12,*,end=302) (ff2(k),k=1,51)      ! file foF2
C	endif
C
	do 11 i=1,51
	 xnm=ff2(i)*ff2(i)*1.24
	rtau=tec(i)/xnm*1000.
C
	if (rtau.lt.2000.) then
	avr2=avr2+rtau
	cnr2=cnr2+1.
	endif
C
	if ((rtau.lt.0.).or.(rtau.gt.1999.)) rtau=1999.
C/	tauav(iut)=tauav(iut)+rtau
   	 ires(i)=nint(rtau)
   11	continue
c	write(*,161) (ires(k),k=1,51)
	write(13,161) (ires(k),k=1,51)
       ENDDO !next lat	  ! LAT cycle
c	itauav(iut)=nint(tauav(iut)/5183.)
	taur2=avr2/cnr2
	write(*,303) AYR,AMN,ADY,AUT,taur2
	write(10,303) AYR,AMN,ADY,AUT,taur2
	endif !+++++++++++++++++++++++++++++++++++++++++++++
  301	close(unit=11)
  302	close(unit=12)
      close(unit=13)
C
  260	continue  ! next UT

  300	CONTINUE
  200	CONTINUE  ! next day
	close(unit=13)
  303 format(1X,4A2,1X,F7.1)
	if (imn.lt.13) goto 1
    2    write(*,*) infile1,infile2,outfile,outmean
      close(unit=10)
    	pause ' '
      STOP
	end