      program tsealand2
C................................................Sep. 2014
C Limit Data for ginev sub-domain: gmlat1,gmlat2,gmlon1,gmlon2 = magnetic coords.
C
C extract from monthly median TECm, foF2m, hmF2m
C nighttime: 22, 23, 24(0), 25(1), 26(2) hrs LT
C daytime: 10, 11, 12, 13, 14 hrs LT
C
C................................................June 2014
C Extract JPL TEC map 
C                     
C geogr.coords. 
C 
C Output: TECave(sea) and TECave(land) monthly mean
C
C ...............................................Jan. 2013
C extract from JPL-TEC map 
C
	CHARACTER*2 AYR,AMN,AUT
c-	+,ADY
	CHARACTER*1 fht,dn
	CHARACTER*65 outfile0,outfile1,infile,infilecp	! 0 ~ sea, 1 ~ land
	      CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ

	INTEGER*2 jyr,jmn,jut
c-	+,jdy1,jdy2,jdy
	logical lout,loutcp
	DIMENSION tec(0:72),res0(12),res1(12)
	+,cglat(71,0:72),cglon(71,0:72)
c-	+,im(12)
c-	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
       CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

	write(*,*) 'Enter f, h or t :'
	read(*,99) fht
c==	write(*,*) 'Enter d (day) or n (night) :'
c== 	read(*,99) dn
	irun=0	 ! Write cp coordinates
c==	irun=1   ! avoid writing cp coordinatesa
c==	if (dn.eq.'d') then
c==	lt1=10
c==	lt2=14
c==	else
c==	lt1=22
c==	lt2=26
c==	endif
C Pacific Ocean, no earthquakes:
	gmlat1=-20.0	 ! geomagn.
	gmlat2=20.0
      gmlon1=300.0
	gmlon2=310.0
c>	glat1=-25.0	 	 ! Geogr.
c>	glat2=25.0
c>      glon1=-125.0
c>	glon2=-110.0
C Pacific Ocean, earthquakes:
c>	glat1=-25.0	 
c>	glat2=25.0
c>      glon1=160.0
c>	glon2=175.0
C Africa
c>	glat1=-25.0	 
c>	glat2=25.0
c>    glon1=20.0
c>	glon2=35.0
C S. America
c>	glat1=-23.0	 
c>	glat2=5.0
c>      glon1=-65.0
c>	glon2=-55.0
C Atlantic
c>	glat1=-23.0	 
c>	glat2=5.0
c>      glon1=-30.0
c>	glon2=-20.0
   99	format(A1)
  103	nn=1
	infilecp='test-180.txt'
	OPEN(15,file=infilecp,action='READ')
C  Read geogr. coord. of magn. c.p. for glat line:
C Read magnetic ccordinats for Ionex sites:
	do ilat=1,71
	do kk=0,72
	read(15,104) yglat,yglon,xglat,xglon
	cglat(ilat,kk)=xglat*(-1.)	 ! IONEX magn. coordinate
	cglon(ilat,kk)=xglon		 ! IONEX magn. coordinate
	enddo
	enddo
	close(unit=15)
C
	outfile0='tseamnar0.txt'		!

	outfile1='tlanmnar1.txt'
	OPEN(10,file=outfile0,access='APPEND')	  ! ocean
	OPEN(11,file=outfile1,access='APPEND')	  ! land
c==	write(*,99) fht,dn
c==	write(10,99) fht,dn
c==	write(11,99) fht,dn
	write(*,98) fht,gmlat1,gmlat2,gmlon1,gmlon2
	write(10,98) fht,gmlat1,gmlat2,gmlon1,gmlon2
	write(11,98) fht,gmlat1,gmlat2,gmlon1,gmlon2

	do i=1,12
	res0(i)=0.
	res1(i)=0.
	enddo

C Read geogr. coords.
   98	format(1X,A1,4(F6.1))
  105	format(4(1X,F6.1))
c  104	format(2(1X,F6.1),15X,2(1X,F6.1)) !c.p. geogr.
  104	format(4(1X,F6.1)) ! c p magn
  102	format(73(1X,F4.1))
  101	format(1X,A2,12(1X,F6.1))
C
	iyr=98
  111	iyr=iyr+1
	 if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,ayr)
c      write(*,*) 'enter AYR='
c	read(*,*) AYR

c-	write(*,*) 'enter AMN='
c-	read(*,*) amn
	infile='d:\web\dts\YR\MN\tcMN00UT.mYR'
	infile(9:9)=fht
	infile(18:18)=fht
	infile(12:13)=AYR
	infile(28:29)=AYR

C Cycle on mn:
	DO jmn=1,12
	call blet2(jmn,AMN)
c-	write(*,*) 'enter idy1,idy2='
c-	read(*,*) jdy1,jdy2
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
c-	jmn=int(rmn)
c//	if(int(ryr/4.)*4.eq.jyr) THEN 
c// 	im(2)=29
c//	                          ELSE
c//	IM(2)=28
c//	ENDIF

c//	jdy1=01
c//	jdy2=im(jmn)
C
	infile(15:16)=AMN
	infile(20:21)=AMN
	tecmn0=0.
	tecmn1=0.
C 
C
C Day-to-day cycle
c//	do 120 jdy=jdy1,jdy2
c//	call blet2(jdy,ADY)
c//	infile(22:23)=ADY
C       
	cnt0=0.
	cnt1=0.
C Cycle on UT
	do 115 jut=0,23
	call blet2(jut,AUT)
	infile(24:25)=AUT
		OPEN(12,file=infile,action='READ')
C
C All lats 
	glat=-90.0
  110	DO 100 ilat=1,71
	glat=glat+2.5
	read(12,102,end=51,err=23) (tec(k),k=0,72) 
C
C
	zglon=-185.
      	DO 90 ilon=0,72 
	zglon=zglon+5.0
	glon=zglon
	if (glon.lt.0.) glon=glon+360.
	if (fht.eq.'h') tec(ilon)=tec(ilon)*10.
c==	hour=jut+glon/15.
c==	if (hour.gt.24.) hour=hour-24.
c==	if (hour.le.2.) hour=hour+24.
c==	lt=nint(hour)
c==	if ((lt.lt.lt1).or.(lt.gt.lt2)) goto 90
c/	if (glat.lt.glat1) goto 90
c/	if (glat.gt.glat2) goto 90
c/	if (zglon.lt.glon1) goto 90
c/	if (zglon.gt.glon2) goto 90
	if (cglat(ilat,ilon).lt.gmlat1) goto 90
	if (cglat(ilat,ilon).gt.gmlat2) goto 90
	if (cglon(ilat,ilon).lt.gmlon1) goto 90
	if (cglon(ilat,ilon).gt.gmlon2) goto 90
C
	call sealand(glat,glon,lout)
CREM	glat1=glat*(-1.)
CREM	call sealand(glat1,glon,loutcp)
c==	glatcp=cglat(ilat,ilon)
c==	gloncp=cglon(ilat,ilon)
c==	glonxx=gloncp
c==	glonyy=gloncp
c==	if (glonyy.gt.180.) glonyy=glonyy-360.0
c==	if (glonxx.lt.0.) glonxx=glonxx+360. 
c==	call sealand(glatcp,glonxx,loutcp)
	if (lout) then
c==	if (lout.and.loutcp) then
	tecmn0=tecmn0+tec(ilon) ! sea
	cnt0=cnt0+1.
c==	if (irun.eq.0) then
c==	write(*,105) glat,zglon,glatcp,glonyy
c==	write(10,105) glat,zglon,glatcp,glonyy
c==	endif
c--	endif
	          else
c==	if ((.not.lout).and.(.not.loutcp)) then
	tecmn1=tecmn1+tec(ilon) ! land
	cnt1=cnt1+1.
c==	if (irun.eq.0) then
c==	write(*,105) glat,zglon,glatcp,glonyy
c==	write(11,105) glat,zglon,glatcp,glonyy
c==	endif
c==	endif
	endif
c-	   ENDDO
   90	CONTINUE
C
  100	continue ! End cycle on ilat
   51 close(unit=12)
  115	CONTINUE        ! End cycle on UT
	irun=irun+1
c	write(*,*) ' DAY =',ADY
  120	CONTINUE        ! End day-to-day cycle
c	cnt0=cnt1*24.*jdy2
c	cnt1=cnt1*24.*jdy2
c?	cnt0=3226.*24.*float(jdy2)
c?	cnt1=1957.*24.*float(jdy2)
	if (cnt0.gt.0.) res0(jmn)=tecmn0/cnt0
	if (cnt1.gt.0.) res1(jmn)=tecmn1/cnt1
	  ENDDO                ! end month-to-month cycle
	write(*,101)  AYR,(res0(k),k=1,12)
	write(10,101) AYR,(res0(k),k=1,12)
	write(*,101)  AYR,(res1(k),k=1,12)
	write(11,101) AYR,(res1(k),k=1,12)
	if (IYR.eq.99) goto 111
	if (IYR.lt.13) goto 111
   23	write(*,*) AYR,AMN
	write(*,89) cnt0,irun
	write(10,89) cnt0,irun
	write(*,89) cnt1,irun
	write(11,89) cnt1,irun
   89	format(1X,F7.0,1X,I6)
	close(unit=10)
	close(unit=11)
c--	close(unit=15)
   	pause ' '
	stop
	end